message3 = NSLOCTEXT("scenario_MPHuskyAssault", "message3", "Allied Reinforcements have landed on the beach east of Gela.")
messagetest = NSLOCTEXT("scenario_MPHuskyAssault", "messagetest", "Prestige injection received. Reinforcements have arrived near Licata.")

SupplyDrop0Lic = {{3,37}}
SupplyDrop1SW = {{2,29}}
SupplyDrop2W = {{4,18}}
SupplyDrop3NW = {{3,7}}
SupplyDrop4SE = {{26,30}}
SupplyDrop5E = {{25,20}}
SupplyDrop6NE = {{26,6}}


function Turn3Landing(action)
		MessageBox("", message3)

		player = 1
		zone = { {20,37},{21,37},{20,38},{21,38},{22,38} }
		units = { {"GBEngineers43", "UniversalCarrier", 2, 1750}, {"GBEngineers43", "UniversalCarrier", 2, 1750}, {"Wasp", "", 2, 1750} , {"6pdrportee", "", 2, 1750}  }

		SpawnWave(player, zone, units)
		
		player = 0
		zone = { {20,37},{21,37},{20,38},{21,38},{22,38} }
		units = { {"M3Satan", "", 5, 2750}  }

		SpawnWave(player, zone, units)
		
end

-- This table is initially empty, and will accumulate depots which we capture
-- Depots won't generate a bonus if we lose them and recapture for the second time
captured_depots = {}

function OnCaptureSupply0(action)

	-- If this flag was not captured by player 0 or 1 (Allies), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	-- Don't generate reward if the same depot is captured for the second time
	if IsItemInTable(captured_depots, action.flag) then return end

	if IsItemInTable(SupplyDrop0Lic, action.flag) then	
	
		local player = world:GetPlayer(1)
		player.prestige = player.prestige + 1500

		local player = world:GetPlayer(0)
		player.prestige = player.prestige + 1500

		player = 1
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"CrusaderAA", "", 2, 1750}, {"HalifaxMkII", "", 2, 1750}, {"HurricaneMkIID", "", 2, 1750} }

		SpawnWave(player, zone, units)
		
		player = 0
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"M4A1", "", 2, 750}, {"M3Lee", "", 4, 1750}, {"M7", "", 1, 750}, {"155mmLongTom", "USTruck", 1, 750}, {"P38G", "", 2, 750},  }

		SpawnWave(player, zone, units)

		MessageBox("", messagetest)
	else
		return
	end
	
		-- Remember that this depot has been captured
	table.insert(captured_depots, action.flag)

end

function OnCaptureSupply1(action)

	-- If this flag was not captured by player 0 or 1 (Allies), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	-- Don't generate reward if the same depot is captured for the second time
	if IsItemInTable(captured_depots, action.flag) then return end

	if IsItemInTable(SupplyDrop1SW, action.flag) then	
	
		local player = world:GetPlayer(1)
		player.prestige = player.prestige + 750

		local player = world:GetPlayer(0)
		player.prestige = player.prestige + 750

		player = 1
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"GBInfantry43", "Lorry", 2, 1750}, {"GBInfantry43", "Lorry", 2, 1750}, {"Bridgelayer", "", 0, 1750}, {"Wasp", "", 2, 1750} }

		SpawnWave(player, zone, units)
		
		player = 0
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"M10Wolverine", "", 2, 750}, {"M10Wolverine", "", 2, 750}, {"M4Sherman", "", 4, 750} }

		SpawnWave(player, zone, units)

		MessageBox("", messagetest)
	else
		return
	end
	
		-- Remember that this depot has been captured
	table.insert(captured_depots, action.flag)

end

function OnCaptureSupply2(action)

	-- If this flag was not captured by player 0 or 1 (Allies), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	-- Don't generate reward if the same depot is captured for the second time
	if IsItemInTable(captured_depots, action.flag) then return end

	if IsItemInTable(SupplyDrop2W, action.flag) then	
	
		local player = world:GetPlayer(1)
		player.prestige = player.prestige + 750

		local player = world:GetPlayer(0)
		player.prestige = player.prestige + 750

		player = 1
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"MosquitoMkVI", "", 1, 1750}, {"StirlingMkIII", "", 1, 1750} }

		SpawnWave(player, zone, units)
		
		player = 0
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"P38G", "", 2, 750}, {"M4Crocodile", "", 3, 750}  }

		SpawnWave(player, zone, units)

		MessageBox("", messagetest)
	else
		return
	end
	
		-- Remember that this depot has been captured
	table.insert(captured_depots, action.flag)

end

function OnCaptureSupply3(action)

	-- If this flag was not captured by player 0 or 1 (Allies), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	-- Don't generate reward if the same depot is captured for the second time
	if IsItemInTable(captured_depots, action.flag) then return end

	if IsItemInTable(SupplyDrop3NW, action.flag) then	
	
		local player = world:GetPlayer(1)
		player.prestige = player.prestige + 500

		local player = world:GetPlayer(0)
		player.prestige = player.prestige + 500

		player = 1
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"GBHWInf43", "UniversalCarrier", 2, 1750}, {"GBHWInf43", "UniversalCarrier", 2, 1750}, {"QF17pounder", "Lorry", 2, 1750} }

		SpawnWave(player, zone, units)
		
		player = 0
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"M18Hellcat", "", 3, 750}, {"M7", "", 4, 750}, {"M4A3", "", 5, 1750}  }

		SpawnWave(player, zone, units)

		MessageBox("", messagetest)
	else
		return
	end
	
		-- Remember that this depot has been captured
	table.insert(captured_depots, action.flag)

end

function OnCaptureSupply4(action)

	-- If this flag was not captured by player 0 or 1 (Allies), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	-- Don't generate reward if the same depot is captured for the second time
	if IsItemInTable(captured_depots, action.flag) then return end

	if IsItemInTable(SupplyDrop4SE, action.flag) then	
	
		local player = world:GetPlayer(1)
		player.prestige = player.prestige + 500

		local player = world:GetPlayer(0)
		player.prestige = player.prestige + 500

		player = 1
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"GBHWInf43", "UniversalCarrier", 2, 1750}, {"GBHWInf43", "UniversalCarrier", 2, 1750}, {"QF17pounder", "Lorry", 2, 1750} }

		SpawnWave(player, zone, units)
		
		player = 0
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"M18Hellcat", "", 3, 750}, {"M7", "", 4, 750}, {"M4A3", "", 5, 1750}  }

		SpawnWave(player, zone, units)

		MessageBox("", messagetest)
	else
		return
	end
	
		-- Remember that this depot has been captured
	table.insert(captured_depots, action.flag)

end

function OnCaptureSupply5(action)

	-- If this flag was not captured by player 0 or 1 (Allies), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	-- Don't generate reward if the same depot is captured for the second time
	if IsItemInTable(captured_depots, action.flag) then return end

	if IsItemInTable(SupplyDrop5E, action.flag) then	
	
		local player = world:GetPlayer(1)
		player.prestige = player.prestige + 1500

		local player = world:GetPlayer(0)
		player.prestige = player.prestige + 1500

		player = 1
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"TyphoonMkIB", "", 4, 1750}, {"LancasterMkIII", "", 4, 1750} }

		SpawnWave(player, zone, units)
		
		player = 0
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"P47B", "", 5, 1750}, {"M4Sherman", "", 10, 2750}  }

		SpawnWave(player, zone, units)

		MessageBox("", messagetest)
	else
		return
	end
	
		-- Remember that this depot has been captured
	table.insert(captured_depots, action.flag)

end

function OnCaptureSupply6(action)

	-- If this flag was not captured by player 0 or 1 (Allies), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	-- Don't generate reward if the same depot is captured for the second time
	if IsItemInTable(captured_depots, action.flag) then return end

	if IsItemInTable(SupplyDrop6NE, action.flag) then	
	
		local player = world:GetPlayer(1)
		player.prestige = player.prestige + 2500

		local player = world:GetPlayer(0)
		player.prestige = player.prestige + 2500

		player = 1
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"SAS", "UniversalCarrier", 5, 3750}, {"Commando", "UniversalCarrier", 5, 3750}, {"ChurchillAVRE", "", 5, 2750} }

		SpawnWave(player, zone, units)
		
		player = 0
		zone = { {1,32},{2,32},{3,32},{4,32},{5,32},{1,33},{2,33},{3,33},{4,33},{1,34},{2,34},{3,34},{4,34},{5,34},{1,35},{2,35},{3,35},{4,35},{1,36},{2,36},{3,36},{4,36} }
		units = { {"M4A3E2", "", 4, 2750}, {"M4A3-76W", "", 4, 2750}, {"155mmM12GMC", "", 4, 2750}  }

		SpawnWave(player, zone, units)

		MessageBox("", messagetest)
	else
		return
	end
	
		-- Remember that this depot has been captured
	table.insert(captured_depots, action.flag)

end	

function IsThirdTurn()
	return world.round == 3
end

-- *** Utility functions ***
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end

	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end


function SpawnWave(player, zone, units)
	local owner = world:GetPlayer(player)

	local cur_hex = 1

	-- Iterate through all units and spawn each one
	for _,u in ipairs(units) do
		-- Find the next vacant hex in the zone
		while zone[cur_hex] do
			hex = world:GetHex(zone[cur_hex])
			if hex:GetUnit(0) == nil then break end -- found
			cur_hex = cur_hex + 1
		end

		-- If we have run out of hexes in the zone, stop
		if not zone[cur_hex] then return end

		-- Create the unit in the free hex we've found
		-- 1. Create and execute purchase action, use unit type, transport type and overstrength as parameters
		local create_action = world:MakePurchaseAction(owner, u[1], u[2], u[3])
		create_action.auxiliary = false -- spawn core units
		create_action.cost = 0 -- don't take money for units we generate
		world:Exec(create_action)

		-- 2. Create and execute deploy action, place the unit in the hex we've picked.
		local unit = world:GetUnit(create_action.id)
		deploy_action = world:MakeDeployAction(unit, zone[cur_hex])
		world:Exec(deploy_action)

		-- 3. Now modify the unit to set its experience to the value we need.
		unit.experience = u[4]
		
		-- 4. Now modify the unit to set its aggressiveness to the value we need.
		player_aggressiveness = { 0, 85, 70, 50 }
		unit.aggressiveness = player_aggressiveness[player+1]
		
	end

end
