function CreateAndAssignEnemyHero1(unit_id)
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = NSLOCTEXT("scenario_AragonOffensive", "EnemyHero", "")
	hero.extra_traits = {UnitTrait.IncMaxOverstrength, UnitTrait.Avenger}
	local action = world:MakeNewHeroAction(2, hero)
	world:Exec(action)

	local assign_hero_action = world:MakeAssignHeroAction(world:GetUnit(unit_id), hero.id)
	world:Exec(assign_hero_action)
end

function EnemyHero()
	CreateAndAssignEnemyHero1(53) -- specify id of the unit which will get this hero
	CreateAndAssignEnemyHero2(35) -- specify id of the unit which will get this hero
end

function CreateAndAssignEnemyHero2(unit_id)
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = NSLOCTEXT("scenario_AragonOffensive", "EnemyHero", "")
	hero.extra_traits = {UnitTrait.FearsomeReputation}
	local action = world:MakeNewHeroAction(2, hero)
	world:Exec(action)

	local assign_hero_action = world:MakeAssignHeroAction(world:GetUnit(unit_id), hero.id)
	world:Exec(assign_hero_action)
end
