--Nemesis scripts
string_death = NSLOCTEXT("scenario_Madrid1939", "string_death", "<bi>Capitana Vega: </>Rest in peace, my misguided brother.")

function Condition2()
	local unit = world:GetUnit(52)
	return unit == nil 
end

function Effect2()
	if (campaign.nemesislives == 1) then
	TutorialMessage(string_death)
	campaign.nemesislives = 0
	end
end

function NemesisCheck()
	if (campaign.nemesislives == 0) then
		local nemesis = world:GetUnit(52)
		local death_action = world:MakeDeathAction(nemesis)
		world:Exec(death_action)
	end
end

function CreateAndAssignNemesis(unit_id)
	local hero = NewHero()
	local unit = world:GetUnit(unit_id)
	if (unit == nil) then return end
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = NSLOCTEXT("scenario_Madrid1939", "Nemesis", "")
	hero.extra_traits = {UnitTrait.IgnoresZOC, UnitTrait.Survivor, UnitTrait.Butcher, UnitTrait.TenaciousDefender, UnitTrait.IncMaxOverstrength}
	local action = world:MakeNewHeroAction(unit.owner_id, hero)
	world:Exec(action)

	local assign_hero_action = world:MakeAssignHeroAction(unit, hero.id)
	world:Exec(assign_hero_action)
end

function NemesisHero()
	CreateAndAssignNemesis(52) -- specify id of the unit which will get this hero
end


-- was ist das?
--function RevealHexes()
--	local player = world:GetPlayer(0)
--	local reveal_action = world:MakeRevealAction(player)
--	reveal_action:Reveal(world, {{13,18},{14,18},{15,18},{12,19},{13,19},{14,19},{15,19},{12,20},{13,20},{14,20},{15,20},{16,20},{8,21},{9,21},{10,21},{11,21},{12,21},{13,21},{8,22},{9,22},{10,22},{11,22},{12,22},{13,22},{8,23},{9,23},{10,23},{12,23},{9,24},{10,24},{11,24}})
--	world:Exec(reveal_action)	
--end
